using ICS.WCF.Base;
using ICSSoft.Entity;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;
using UFSoft.UBF.Service;
using UFSoft.UBF.Util.Context;

namespace ICS.DeleteMiscShip
{
    public class DeleteMiscShipCode
    {
        public Result CustDeleteMiscShip(List<string> DocList, string OrgID)
        {
            long DocID = 0;
            #region 服务调用框架结构
            //实例化代理类 
            UFIDAU9ISVMiscShipISVICommonDeleteMiscShipClient client = new UFIDAU9ISVMiscShipISVICommonDeleteMiscShipClient();
            //返回异常信息，目前还没有使用此属性
            UFSoft.UBF.Exceptions1.MessageBase[] returnMsg;
            //上下文信息
            object context;

            var res = new Result();
            www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] docArray = new www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData[] { };
            List<www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData> docList = new List<www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData>();
            try
            {
                foreach (string DocCode in DocList)
                {
                    DataTable dt = GetData(DocCode, OrgID);
                    if (dt.Rows.Count > 0)
                    {
                        DocID = long.Parse(dt.Rows[0]["ID"].ToString());
                    }
                    else
                    {
                        throw new Exception("需要删除的单据号不正确!");
                    }

                    www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData docinfo = new www.ufida.org.EntityData.UFIDAU9CBOPubControllerCommonArchiveDataDTOData();
                    //给传入参数赋值
                    docinfo.m_iD = DocID;
                    docList.Add(docinfo);
                    docArray = docList.ToArray();
                }

                //给上下文信息赋值
                context = CreateContextObj(OrgID);

                //服务调用
                (client.Endpoint.Binding as BasicHttpBinding).MaxReceivedMessageSize = int.MaxValue;
                (client.Endpoint.Binding as BasicHttpBinding).MaxBufferSize = int.MaxValue;
                returnMsg = client.Do(context, docArray);
                foreach (var item in returnMsg)
                {
                    if (!string.IsNullOrEmpty(item.localMessage))
                    {
                        throw new Exception(item.localMessage);
                    }
                }
                res.Success = true;
                res.Message = "成功";
            }
            catch (Exception ex)
            {
                res.Success = false;
                res.Message = ex.Message;
            }
            return res;
            #endregion
        }

        private DataTable GetData(string DocCode, string OrgID)
        {
            string sql = @"select  ID
                           from   InvDoc_MiscShip  
                           where DocNo='" + DocCode + "' AND Org='" + OrgID + "' ";
            return DBhlper.Query(sql, Appconfig.GetU9ConnStr());
        }

        #region 提取异常信息
        /// <summary>
        /// 提取异常信息
        /// </summary>
        /// <param name="ex"></param>
        private static string GetExceptionMessage(Exception ex)
        {
            string faultMessage = "未知错误，请查看ERP日志！";

            System.TimeoutException timeoutEx = ex as System.TimeoutException;
            if (timeoutEx != null)
            {
                faultMessage = "访问服务超时，请修改配置信息！";
            }
            else
            {
                FaultException<ServiceException> faultEx = ex as FaultException<ServiceException>;
                if (faultEx == null)
                {
                    faultMessage = ex.Message;
                }
                else
                {
                    ServiceException serviceEx = faultEx.Detail;
                    if (serviceEx != null && !string.IsNullOrEmpty(serviceEx.Message)
                        && !serviceEx.Message.Equals("fault", StringComparison.OrdinalIgnoreCase))
                    {
                        // 错误信息在faultEx.Message中，请提取，
                        // 格式为"Fault:料品不能为空，请录入\n 在....."
                        int startIndex = serviceEx.Message.IndexOf(":");
                        int endIndex = serviceEx.Message.IndexOf("\n");
                        if (endIndex == -1)
                            endIndex = serviceEx.Message.Length;
                        if (endIndex > 0 && endIndex > startIndex + 1)
                        {
                            faultMessage = serviceEx.Message.Substring(startIndex + 1, endIndex - startIndex - 1);
                        }
                        else
                        {
                            faultMessage = serviceEx.Message;
                        }
                    }
                }
            }
            return faultMessage;
        }
        #endregion

        #region 给上下文信息赋值
        /// <summary>
        /// 给上下文信息赋值
        /// </summary>
        /// <returns></returns>
        private static ThreadContext CreateContextObj(string OrgID)
        {
            // 实例化应用上下文对象
            ThreadContext thContext = new ThreadContext();


            System.Collections.Generic.Dictionary<object, object> ns = new Dictionary<object, object>();
            ns.Add("OrgID", OrgID);
            ns.Add("UserID", ConfigurationManager.AppSettings["userID"].ToString());
            ns.Add("UserCode", ConfigurationManager.AppSettings["userCode"].ToString());
            ns.Add("Datetime", DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss"));
            ns.Add("CultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            ns.Add("EnterpriseID", ConfigurationManager.AppSettings["enterpriseID"].ToString());
            ns.Add("DefaultCultureName", ConfigurationManager.AppSettings["cultureName"].ToString());
            thContext.nameValueHas = ns;

            return thContext;
        }
        #endregion
    }
}
